module MediServ::API
  require_relative "encoder"
  require_relative "error"
  require_relative "types"

  class Client
    # * *Args*    :
    def initialize(clientId, storage)
      @storage = storage
      @encoder = MediServ::API::Encoder.new
      @default_header = {
        programm: 'Denteo MediServ Client',
        programm_version: '0.3.0', # TODO: Load from gemspec
        version: 'v2',
        kundennummer: clientId,
        stapelnummer: 0,
      }
    end

    def batch(id, invoices, created_at: DateTime.now)
      b = MediServ::API::Batch.new({
        allgemein: @default_header.merge({
          stapelnummer: id,
        }),
        rechnungen: invoices,
        created_at: created_at,
      })
      @storage.put(id, @encoder.encode(b.to_h))
    end
  end
end
